//-----------------------------------------------------------------------------
// F326_AES_InvCipher.h
//-----------------------------------------------------------------------------
// Copyright 2007 Silicon Laboratories, Inc.
// http://www.silabs.com
//
// Program Description:
//
//
// How To Test:    See Readme.txt
//
//           
// Target:         C8051F326
// Tool chain:     Keil C51 7.50 / Keil EVAL C51
//                 Silicon Laboratories IDE version 2.91
// Command Line:   See Readme.txt
// Project Name:   F326_AES
//
//
// Release 1.0
//    -Initial Revision (CG/GP)
//    -11 JUN 2007
//

#ifndef _F326_AES_INVCIPHER_H_
#define _F326_AES_INVCIPHER_H_

//-----------------------------------------------------------------------------
// Typdefs
//-----------------------------------------------------------------------------

#include "F326_AES_Typedef.h"

//-----------------------------------------------------------------------------
// Prototypes
//-----------------------------------------------------------------------------

void InvCipher (byte *in, byte *out);

//-----------------------------------------------------------------------------
// Global Constants
//-----------------------------------------------------------------------------

static 
byte const code InvSbox[256] = 
{ 0x52, 0x09, 0x6a, 0xd5, 0x30, 0x36, 0xa5, 0x38,  //0      
  0xbf, 0x40, 0xa3, 0x9e, 0x81, 0xf3, 0xd7, 0xfb,  //8      
  0x7c, 0xe3, 0x39, 0x82, 0x9b, 0x2f, 0xff, 0x87,  //16     
  0x34, 0x8e, 0x43, 0x44, 0xc4, 0xde, 0xe9, 0xcb,  //24     
  0x54, 0x7b, 0x94, 0x32, 0xa6, 0xc2, 0x23, 0x3d,  //32     
  0xee, 0x4c, 0x95, 0x0b, 0x42, 0xfa, 0xc3, 0x4e,  //40     
  0x08, 0x2e, 0xa1, 0x66, 0x28, 0xd9, 0x24, 0xb2,  //48     
  0x76, 0x5b, 0xa2, 0x49, 0x6d, 0x8b, 0xd1, 0x25,  //56     
  0x72, 0xf8, 0xf6, 0x64, 0x86, 0x68, 0x98, 0x16,  //64     
  0xd4, 0xa4, 0x5c, 0xcc, 0x5d, 0x65, 0xb6, 0x92,  //72     
  0x6c, 0x70, 0x48, 0x50, 0xfd, 0xed, 0xb9, 0xda,  //80     
  0x5e, 0x15, 0x46, 0x57, 0xa7, 0x8d, 0x9d, 0x84,  //88     
  0x90, 0xd8, 0xab, 0x00, 0x8c, 0xbc, 0xd3, 0x0a,  //96     
  0xf7, 0xe4, 0x58, 0x05, 0xb8, 0xb3, 0x45, 0x06,  //104    
  0xd0, 0x2c, 0x1e, 0x8f, 0xca, 0x3f, 0x0f, 0x02,  //112    
  0xc1, 0xaf, 0xbd, 0x03, 0x01, 0x13, 0x8a, 0x6b,  //120    
  0x3a, 0x91, 0x11, 0x41, 0x4f, 0x67, 0xdc, 0xea,  //128    
  0x97, 0xf2, 0xcf, 0xce, 0xf0, 0xb4, 0xe6, 0x73,  //136    
  0x96, 0xac, 0x74, 0x22, 0xe7, 0xad, 0x35, 0x85,  //144    
  0xe2, 0xf9, 0x37, 0xe8, 0x1c, 0x75, 0xdf, 0x6e,  //152    
  0x47, 0xf1, 0x1a, 0x71, 0x1d, 0x29, 0xc5, 0x89,  //160    
  0x6f, 0xb7, 0x62, 0x0e, 0xaa, 0x18, 0xbe, 0x1b,  //168    
  0xfc, 0x56, 0x3e, 0x4b, 0xc6, 0xd2, 0x79, 0x20,  //176    
  0x9a, 0xdb, 0xc0, 0xfe, 0x78, 0xcd, 0x5a, 0xf4,  //184    
  0x1f, 0xdd, 0xa8, 0x33, 0x88, 0x07, 0xc7, 0x31,  //192    
  0xb1, 0x12, 0x10, 0x59, 0x27, 0x80, 0xec, 0x5f,  //200    
  0x60, 0x51, 0x7f, 0xa9, 0x19, 0xb5, 0x4a, 0x0d,  //208    
  0x2d, 0xe5, 0x7a, 0x9f, 0x93, 0xc9, 0x9c, 0xef,  //216    
  0xa0, 0xe0, 0x3b, 0x4d, 0xae, 0x2a, 0xf5, 0xb0,  //224    
  0xc8, 0xeb, 0xbb, 0x3c, 0x83, 0x53, 0x99, 0x61,  //232    
  0x17, 0x2b, 0x04, 0x7e, 0xba, 0x77, 0xd6, 0x26,  //240    
  0xe1, 0x69, 0x14, 0x63, 0x55, 0x21, 0x0c, 0x7d}; //248  

// Log Table for InvMixColumn Lookup

static
byte const code log_table[256] = 
{0x00, 0x00, 0xc8, 0x08, 0x91, 0x10, 0xd0, 0x36, 0x5a, 0x3e, 0xd8, 0x43, 0x99, 0x77, 0xfe, 0x18, //0x00-0x0F
 0x23, 0x20, 0x07, 0x70, 0xa1, 0x6c, 0x0c, 0x7f, 0x62, 0x8b, 0x40, 0x46, 0xc7, 0x4b, 0xe0, 0x0e, //0x10-0x1F
 0xeb, 0x16, 0xe8, 0xad, 0xcf, 0xcd, 0x39, 0x53, 0x6a, 0x27, 0x35, 0x93, 0xd4, 0x4e, 0x48, 0xc3, //0x20-0x2F
 0x2b, 0x79, 0x54, 0x28, 0x09, 0x78, 0x0f, 0x21, 0x90, 0x87, 0x14, 0x2a, 0xa9, 0x9c, 0xd6, 0x74, //0x30-0x3F
 0xb4, 0x7c, 0xde, 0xed, 0xb1, 0x86, 0x76, 0xa4, 0x98, 0xe2, 0x96, 0x8f, 0x02, 0x32, 0x1c, 0xc1, //0x40-0x4F
 0x33, 0xee, 0xef, 0x81, 0xfd, 0x30, 0x5c, 0x13, 0x9d, 0x29, 0x17, 0xc4, 0x11, 0x44, 0x8c, 0x80, //0x50-0x5F
 0xf3, 0x73, 0x42, 0x1e, 0x1d, 0xb5, 0xf0, 0x12, 0xd1, 0x5b, 0x41, 0xa2, 0xd7, 0x2c, 0xe9, 0xd5, //0x60-0x6F
 0x59, 0xcb, 0x50, 0xa8, 0xdc, 0xfc, 0xf2, 0x56, 0x72, 0xa6, 0x65, 0x2f, 0x9f, 0x9b, 0x3d, 0xba, //0x70-0x7F
 0x7d, 0xc2, 0x45, 0x82, 0xa7, 0x57, 0xb6, 0xa3, 0x7a, 0x75, 0x4f, 0xae, 0x3f, 0x37, 0x6d, 0x47, //0x80-0x8F
 0x61, 0xbe, 0xab, 0xd3, 0x5f, 0xb0, 0x58, 0xaf, 0xca, 0x5e, 0xfa, 0x85, 0xe4, 0x4d, 0x8a, 0x05, //0x90-0x9F
 0xfb, 0x60, 0xb7, 0x7b, 0xb8, 0x26, 0x4a, 0x67, 0xc6, 0x1a, 0xf8, 0x69, 0x25, 0xb3, 0xdb, 0xbd, //0xA0-0xAF
 0x66, 0xdd, 0xf1, 0xd2, 0xdf, 0x03, 0x8d, 0x34, 0xd9, 0x92, 0x0d, 0x63, 0x55, 0xaa, 0x49, 0xec, //0xB0-0xBF
 0xbc, 0x95, 0x3c, 0x84, 0x0b, 0xf5, 0xe6, 0xe7, 0xe5, 0xac, 0x7e, 0x6e, 0xb9, 0xf9, 0xda, 0x8e, //0xC0-0xCF
 0x9a, 0xc9, 0x24, 0xe1, 0x0a, 0x15, 0x6b, 0x3a, 0xa0, 0x51, 0xf4, 0xea, 0xb2, 0x97, 0x9e, 0x5d, //0xD0-0xDF
 0x22, 0x88, 0x94, 0xce, 0x19, 0x01, 0x71, 0x4c, 0xa5, 0xe3, 0xc5, 0x31, 0xbb, 0xcc, 0x1f, 0x2d, //0xE0-0xEF
 0x3b, 0x52, 0x6f, 0xf6, 0x2e, 0x89, 0xf7, 0xc0, 0x68, 0x1b, 0x64, 0x04, 0x06, 0xbf, 0x83, 0x38}; //0xF0-0xFF

// Exponentiation Table for InvMixColumn Lookup

static
byte const code exp_table[256] =
{0x01, 0xE5, 0x4C, 0xB5, 0xFB, 0x9F, 0xFC, 0x12, 0x03, 0x34, 0xD4, 0xC4, 0x16, 0xBA, 0x1F, 0x36,
 0x05, 0x5C, 0x67, 0x57, 0x3A, 0xD5, 0x21, 0x5A, 0x0F, 0xE4, 0xA9, 0xF9, 0x4E, 0x64, 0x63, 0xEE,
 0x11, 0x37, 0xE0, 0x10, 0xD2, 0xAC, 0xA5, 0x29, 0x33, 0x59, 0x3B, 0x30, 0x6D, 0xEF, 0xF4, 0x7B,
 0x55, 0xEB, 0x4D, 0x50, 0xB7, 0x2A, 0x07, 0x8D, 0xFF, 0x26, 0xD7, 0xF0, 0xC2, 0x7E, 0x09, 0x8C,
 0x1A, 0x6A, 0x62, 0x0B, 0x5D, 0x82, 0x1B, 0x8F, 0x2E, 0xBE, 0xA6, 0x1D, 0xE7, 0x9D, 0x2D, 0x8A,
 0x72, 0xD9, 0xF1, 0x27, 0x32, 0xBC, 0x77, 0x85, 0x96, 0x70, 0x08, 0x69, 0x56, 0xDF, 0x99, 0x94,
 0xA1, 0x90, 0x18, 0xBB, 0xFA, 0x7A, 0xB0, 0xA7, 0xF8, 0xAB, 0x28, 0xD6, 0x15, 0x8E, 0xCB, 0xF2,
 0x13, 0xE6, 0x78, 0x61, 0x3F, 0x89, 0x46, 0x0D, 0x35, 0x31, 0x88, 0xA3, 0x41, 0x80, 0xCA, 0x17,
 0x5F, 0x53, 0x83, 0xFE, 0xC3, 0x9B, 0x45, 0x39, 0xE1, 0xF5, 0x9E, 0x19, 0x5E, 0xB6, 0xCF, 0x4B,
 0x38, 0x04, 0xB9, 0x2B, 0xE2, 0xC1, 0x4A, 0xDD, 0x48, 0x0C, 0xD0, 0x7D, 0x3D, 0x58, 0xDE, 0x7C,
 0xD8, 0x14, 0x6B, 0x87, 0x47, 0xE8, 0x79, 0x84, 0x73, 0x3C, 0xBD, 0x92, 0xC9, 0x23, 0x8B, 0x97,
 0x95, 0x44, 0xDC, 0xAD, 0x40, 0x65, 0x86, 0xA2, 0xA4, 0xCC, 0x7F, 0xEC, 0xC0, 0xAF, 0x91, 0xFD,
 0xF7, 0x4F, 0x81, 0x2F, 0x5B, 0xEA, 0xA8, 0x1C, 0x02, 0xD1, 0x98, 0x71, 0xED, 0x25, 0xE3, 0x24,
 0x06, 0x68, 0xB3, 0x93, 0x2C, 0x6F, 0x3E, 0x6C, 0x0A, 0xB8, 0xCE, 0xAE, 0x74, 0xB1, 0x42, 0xB4,
 0x1E, 0xD3, 0x49, 0xE9, 0x9C, 0xC8, 0xC6, 0xC7, 0x22, 0x6E, 0xDB, 0x20, 0xBF, 0x43, 0x51, 0x52,
 0x66, 0xB2, 0x76, 0x60, 0xDA, 0xC5, 0xF3, 0xF6, 0xAA, 0xCD, 0x9A, 0xA0, 0x75, 0x54, 0x0E, 0x01};


//-----------------------------------------------------------------------------
// Close File Definition
//-----------------------------------------------------------------------------

#endif  

//-----------------------------------------------------------------------------
// End Of File
//-----------------------------------------------------------------------------